/**
 * This class was generated from a set of XML constraints
 *   by the Enhydra Zeus XML Data Binding Framework. All
 *   source code in this file is constructed specifically
 *   to work with other Zeus-generated classes. If you
 *   modify this file by hand, you run the risk of breaking
 *   this interoperation, as well as introducing errors in
 *   source code compilation.
 *
 * * * * * MODIFY THIS FILE AT YOUR OWN RISK * * * * *
 *
 * To find out more about the Enhydra Zeus framework, you
 *   can point your browser at <http://zeus.enhydra.org>
 *   where you can download releases, join and discuss Zeus
 *   on user and developer mailing lists, and access source
 *   code. Please report any bugs through that website.
 */
package org.objectweb.jonas_web.deployment.xml;

// Global Implementation Import Statements
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Reader;
import java.io.Writer;
import org.xml.sax.Attributes;
import org.xml.sax.EntityResolver;
import org.xml.sax.ErrorHandler;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.XMLReaderFactory;

// Local Implementation Import Statements
import java.util.Iterator;
import java.util.List;
import java.util.LinkedList;

public class FilterImpl extends DefaultHandler implements Unmarshallable, Filter {

    private Icon icon;
    private FilterName filterName;
    private DisplayName displayName;
    private Description description;
    private FilterClass filterClass;
    private List initParamList;
    private String id;
    private boolean zeus_idSet;

    /** The current node in unmarshalling */
    private Unmarshallable zeus_currentUNode;

    /** The parent node in unmarshalling */
    private Unmarshallable zeus_parentUNode;

    /** Whether this node has been handled */
    private boolean zeus_thisNodeHandled = false;

    /** The EntityResolver for SAX parsing to use */
    private static EntityResolver entityResolver;

    /** The ErrorHandler for SAX parsing to use */
    private static ErrorHandler errorHandler;

    public FilterImpl() {
        initParamList = new LinkedList();
        zeus_idSet = false;
    }

    public Icon getIcon() {
        return icon;
    }

    public void setIcon(Icon icon) {
        this.icon = icon;
    }

    public FilterName getFilterName() {
        return filterName;
    }

    public void setFilterName(FilterName filterName) {
        this.filterName = filterName;
    }

    public DisplayName getDisplayName() {
        return displayName;
    }

    public void setDisplayName(DisplayName displayName) {
        this.displayName = displayName;
    }

    public Description getDescription() {
        return description;
    }

    public void setDescription(Description description) {
        this.description = description;
    }

    public FilterClass getFilterClass() {
        return filterClass;
    }

    public void setFilterClass(FilterClass filterClass) {
        this.filterClass = filterClass;
    }

    public List getInitParamList() {
        return initParamList;
    }

    public void setInitParamList(List initParamList) {
        this.initParamList = initParamList;
    }

    public void addInitParam(InitParam initParam) {
        initParamList.add(initParam);
    }

    public void removeInitParam(InitParam initParam) {
        initParamList.remove(initParam);
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
        zeus_idSet = true;
    }

    public void marshal(File file) throws IOException {
        // Delegate to the marshal(Writer) method
        marshal(new FileWriter(file));
    }

    public void marshal(OutputStream outputStream) throws IOException {
        // Delegate to the marshal(Writer) method
        marshal(new OutputStreamWriter(outputStream));
    }

    public void marshal(Writer writer) throws IOException {
        // Write out the XML declaration
        writer.write("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n\n");

        // Now start the recursive writing
        writeXMLRepresentation(writer, "");

        // Close up
        writer.flush();
        writer.close();
    }

    protected void writeXMLRepresentation(Writer writer,
                                          String indent)
        throws IOException {

        writer.write(indent);
        writer.write("<filter");

        // Handle attributes (if needed)
        if (zeus_idSet) {
            writer.write(" id=\"");
            writer.write(escapeAttributeValue(id));
            writer.write("\"");
        }
        writer.write(">");
        writer.write("\n");

        // Handle child elements
        if (icon != null) {
            ((IconImpl)icon).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (filterName != null) {
            ((FilterNameImpl)filterName).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (displayName != null) {
            ((DisplayNameImpl)displayName).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (description != null) {
            ((DescriptionImpl)description).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (filterClass != null) {
            ((FilterClassImpl)filterClass).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        for (Iterator i=initParamList.iterator(); i.hasNext(); ) {
            InitParamImpl initParam = (InitParamImpl)i.next();
            initParam.writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }
        writer.write(indent);
        writer.write("</filter>\n");
    }

    private String escapeAttributeValue(String attributeValue) {
        String returnValue = attributeValue;
        for (int i = 0; i < returnValue.length(); i++) {
            char ch = returnValue.charAt(i);
            if (ch == '"') {
                returnValue = new StringBuffer()
                    .append(returnValue.substring(0, i))
                    .append("&quot;")
                    .append(returnValue.substring(i+1))
                    .toString();
            }
        }
        return returnValue;
    }

    /**
     * <p>
     *  This sets a SAX <code>EntityResolver</code> for this unmarshalling process.
     * </p>
     *
     * @param resolver the entity resolver to use.
     */
    public static void setEntityResolver(EntityResolver resolver) {
        entityResolver = resolver;
    }

    /**
     * <p>
     *  This sets a SAX <code>ErrorHandler</code> for this unmarshalling process.
     * </p>
     *
     * @param handler the entity resolver to use.
     */
    public static void setErrorHandler(ErrorHandler handler) {
        errorHandler = handler;
    }

    public static Filter unmarshal(File file) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new FileReader(file));
    }

    public static Filter unmarshal(File file, boolean validate) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new FileReader(file), validate);
    }

    public static Filter unmarshal(InputStream inputStream) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new InputStreamReader(inputStream));
    }

    public static Filter unmarshal(InputStream inputStream, boolean validate) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new InputStreamReader(inputStream), validate);
    }

    public static Filter unmarshal(Reader reader) throws IOException {
        // Delegate with default validation value
        return unmarshal(reader, false);
    }

    public static Filter unmarshal(Reader reader, boolean validate) throws IOException {
        FilterImpl filter = new FilterImpl();
        filter.setCurrentUNode(filter);
        filter.setParentUNode(null);
        // Load the XML parser
        XMLReader parser = null;
        String parserClass = System.getProperty("org.xml.sax.driver",
            "org.apache.xerces.parsers.SAXParser");
        try {
            parser = XMLReaderFactory.createXMLReader(parserClass);

            // Set entity resolver, if needed
            if (entityResolver != null) {
                parser.setEntityResolver(entityResolver);
            }

            // Set error handler, if needed
            if (errorHandler != null) {
                parser.setErrorHandler(errorHandler);
            }

            // Register content handler
            parser.setContentHandler(filter);
        } catch (SAXException e) {
            throw new IOException("Could not load XML parser: " + 
                e.getMessage());
        }

        InputSource inputSource = new InputSource(reader);
        try {
            parser.setFeature("http://xml.org/sax/features/validation", new Boolean(validate).booleanValue());
            parser.parse(inputSource);
        } catch (SAXException e) {
            throw new IOException("Error parsing XML document: " + 
                e.getMessage());
        }

        // Return the resultant object
        return filter;
    }

    public Unmarshallable getParentUNode() {
        return zeus_parentUNode;
    }

    public void setParentUNode(Unmarshallable parentUNode) {
        this.zeus_parentUNode = parentUNode;
    }

    public Unmarshallable getCurrentUNode() {
        return zeus_currentUNode;
    }

    public void setCurrentUNode(Unmarshallable currentUNode) {
        this.zeus_currentUNode = currentUNode;
    }

    public void startElement(String namespaceURI, String localName,
                             String qName, Attributes atts)
        throws SAXException {

        // Feed this to the correct ContentHandler
        Unmarshallable current = getCurrentUNode();
        if (current != this) {
            current.startElement(namespaceURI, localName, qName, atts);
            return;
        }

        // See if we handle, or we delegate
        if ((localName.equals("filter")) && (!zeus_thisNodeHandled)) {
            // Handle ourselves
            for (int i=0, len=atts.getLength(); i<len; i++) {
                String attName= atts.getLocalName(i);
                String attValue = atts.getValue(i);
                if (attName.equals("id")) {
                    setId(attValue);
                }
            }
            zeus_thisNodeHandled = true;
            return;
        } else {
            // Delegate handling
            if (localName.equals("icon")) {
                IconImpl icon = new IconImpl();
                current = getCurrentUNode();
                icon.setParentUNode(current);
                icon.setCurrentUNode(icon);
                this.setCurrentUNode(icon);
                icon.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.icon = icon;
                return;
            }
            if (localName.equals("filter-name")) {
                FilterNameImpl filterName = new FilterNameImpl();
                current = getCurrentUNode();
                filterName.setParentUNode(current);
                filterName.setCurrentUNode(filterName);
                this.setCurrentUNode(filterName);
                filterName.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.filterName = filterName;
                return;
            }
            if (localName.equals("display-name")) {
                DisplayNameImpl displayName = new DisplayNameImpl();
                current = getCurrentUNode();
                displayName.setParentUNode(current);
                displayName.setCurrentUNode(displayName);
                this.setCurrentUNode(displayName);
                displayName.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.displayName = displayName;
                return;
            }
            if (localName.equals("description")) {
                DescriptionImpl description = new DescriptionImpl();
                current = getCurrentUNode();
                description.setParentUNode(current);
                description.setCurrentUNode(description);
                this.setCurrentUNode(description);
                description.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.description = description;
                return;
            }
            if (localName.equals("filter-class")) {
                FilterClassImpl filterClass = new FilterClassImpl();
                current = getCurrentUNode();
                filterClass.setParentUNode(current);
                filterClass.setCurrentUNode(filterClass);
                this.setCurrentUNode(filterClass);
                filterClass.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.filterClass = filterClass;
                return;
            }
            if (localName.equals("init-param")) {
                InitParamImpl initParam = new InitParamImpl();
                current = getCurrentUNode();
                initParam.setParentUNode(current);
                initParam.setCurrentUNode(initParam);
                this.setCurrentUNode(initParam);
                initParam.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                initParamList.add(initParam);
                return;
            }
        }
    }

    public void endElement(String namespaceURI, String localName,
                           String qName)
        throws SAXException {

        Unmarshallable current = getCurrentUNode();
        if (current != this) {
            current.endElement(namespaceURI, localName, qName);
            return;
        }

        Unmarshallable parent = getCurrentUNode().getParentUNode();
        if (parent != null) {
            parent.setCurrentUNode(parent);
        }
    }

    public void characters(char[] ch, int start, int len)
        throws SAXException {

        // Feed this to the correct ContentHandler
        Unmarshallable current = getCurrentUNode();
        if (current != this) {
            current.characters(ch, start, len);
            return;
        }

        String text = new String(ch, start, len);
        text = text.trim();
    }

}
