/**
 * This class was generated from a set of XML constraints
 *   by the Enhydra Zeus XML Data Binding Framework. All
 *   source code in this file is constructed specifically
 *   to work with other Zeus-generated classes. If you
 *   modify this file by hand, you run the risk of breaking
 *   this interoperation, as well as introducing errors in
 *   source code compilation.
 *
 * * * * * MODIFY THIS FILE AT YOUR OWN RISK * * * * *
 *
 * To find out more about the Enhydra Zeus framework, you
 *   can point your browser at <http://zeus.enhydra.org>
 *   where you can download releases, join and discuss Zeus
 *   on user and developer mailing lists, and access source
 *   code. Please report any bugs through that website.
 */
package org.objectweb.jonas_web.deployment.xml;

// Global Interface Import Statements
import java.io.File;
import java.io.IOException;
import java.io.OutputStream;
import java.io.Writer;

// Local Interface Import Statements
import java.util.List;
import java.io.Serializable;

public interface WebApp extends Serializable {

    public static final String ZEUS_XML_NAME = "web-app";
    public static final String[] ZEUS_ATTRIBUTES = {"id"};
    public static final String[] ZEUS_ELEMENTS = {"icon", "display-name", "description", "distributable", "context-param", "filter", "filter-mapping", "listener", "servlet", "servlet-mapping", "session-config", "mime-mapping", "welcome-file-list", "error-page", "taglib", "resource-env-ref", "resource-ref", "security-constraint", "login-config", "security-role", "env-entry", "ejb-ref", "ejb-local-ref"};

    public Icon getIcon();

    public void setIcon(Icon icon);

    public DisplayName getDisplayName();

    public void setDisplayName(DisplayName displayName);

    public Description getDescription();

    public void setDescription(Description description);

    public Distributable getDistributable();

    public void setDistributable(Distributable distributable);

    public List getContextParamList();

    public void setContextParamList(List contextParamList);

    public void addContextParam(ContextParam contextParam);

    public void removeContextParam(ContextParam contextParam);

    public List getFilterList();

    public void setFilterList(List filterList);

    public void addFilter(Filter filter);

    public void removeFilter(Filter filter);

    public List getFilterMappingList();

    public void setFilterMappingList(List filterMappingList);

    public void addFilterMapping(FilterMapping filterMapping);

    public void removeFilterMapping(FilterMapping filterMapping);

    public List getListenerList();

    public void setListenerList(List listenerList);

    public void addListener(Listener listener);

    public void removeListener(Listener listener);

    public List getServletList();

    public void setServletList(List servletList);

    public void addServlet(Servlet servlet);

    public void removeServlet(Servlet servlet);

    public List getServletMappingList();

    public void setServletMappingList(List servletMappingList);

    public void addServletMapping(ServletMapping servletMapping);

    public void removeServletMapping(ServletMapping servletMapping);

    public SessionConfig getSessionConfig();

    public void setSessionConfig(SessionConfig sessionConfig);

    public List getMimeMappingList();

    public void setMimeMappingList(List mimeMappingList);

    public void addMimeMapping(MimeMapping mimeMapping);

    public void removeMimeMapping(MimeMapping mimeMapping);

    public WelcomeFileList getWelcomeFileList();

    public void setWelcomeFileList(WelcomeFileList welcomeFileList);

    public List getErrorPageList();

    public void setErrorPageList(List errorPageList);

    public void addErrorPage(ErrorPage errorPage);

    public void removeErrorPage(ErrorPage errorPage);

    public List getTaglibList();

    public void setTaglibList(List taglibList);

    public void addTaglib(Taglib taglib);

    public void removeTaglib(Taglib taglib);

    public List getResourceEnvRefList();

    public void setResourceEnvRefList(List resourceEnvRefList);

    public void addResourceEnvRef(ResourceEnvRef resourceEnvRef);

    public void removeResourceEnvRef(ResourceEnvRef resourceEnvRef);

    public List getResourceRefList();

    public void setResourceRefList(List resourceRefList);

    public void addResourceRef(ResourceRef resourceRef);

    public void removeResourceRef(ResourceRef resourceRef);

    public List getSecurityConstraintList();

    public void setSecurityConstraintList(List securityConstraintList);

    public void addSecurityConstraint(SecurityConstraint securityConstraint);

    public void removeSecurityConstraint(SecurityConstraint securityConstraint);

    public LoginConfig getLoginConfig();

    public void setLoginConfig(LoginConfig loginConfig);

    public List getSecurityRoleList();

    public void setSecurityRoleList(List securityRoleList);

    public void addSecurityRole(SecurityRole securityRole);

    public void removeSecurityRole(SecurityRole securityRole);

    public List getEnvEntryList();

    public void setEnvEntryList(List envEntryList);

    public void addEnvEntry(EnvEntry envEntry);

    public void removeEnvEntry(EnvEntry envEntry);

    public List getEjbRefList();

    public void setEjbRefList(List ejbRefList);

    public void addEjbRef(EjbRef ejbRef);

    public void removeEjbRef(EjbRef ejbRef);

    public List getEjbLocalRefList();

    public void setEjbLocalRefList(List ejbLocalRefList);

    public void addEjbLocalRef(EjbLocalRef ejbLocalRef);

    public void removeEjbLocalRef(EjbLocalRef ejbLocalRef);

    public String getId();

    public void setId(String id);

    public void marshal(File file) throws IOException;

    public void marshal(OutputStream outputStream) throws IOException;

    public void marshal(Writer writer) throws IOException;

}
