/**
 * This class was generated from a set of XML constraints
 *   by the Enhydra Zeus XML Data Binding Framework. All
 *   source code in this file is constructed specifically
 *   to work with other Zeus-generated classes. If you
 *   modify this file by hand, you run the risk of breaking
 *   this interoperation, as well as introducing errors in
 *   source code compilation.
 *
 * * * * * MODIFY THIS FILE AT YOUR OWN RISK * * * * *
 *
 * To find out more about the Enhydra Zeus framework, you
 *   can point your browser at <http://zeus.enhydra.org>
 *   where you can download releases, join and discuss Zeus
 *   on user and developer mailing lists, and access source
 *   code. Please report any bugs through that website.
 */
package org.objectweb.jonas_ear.deployment.xml;

// Global Interface Import Statements
import java.io.File;
import java.io.IOException;
import java.io.OutputStream;
import java.io.Writer;

// Local Interface Import Statements
import java.util.List;
import java.io.Serializable;

public interface Application extends Serializable {

    public static final String ZEUS_XML_NAME = "application";
    public static final String[] ZEUS_ATTRIBUTES = {"id"};
    public static final String[] ZEUS_ELEMENTS = {"icon", "display-name", "description", "module", "security-role"};

    public Icon getIcon();

    public void setIcon(Icon icon);

    public DisplayName getDisplayName();

    public void setDisplayName(DisplayName displayName);

    public Description getDescription();

    public void setDescription(Description description);

    public List getModuleList();

    public void setModuleList(List moduleList);

    public void addModule(Module module);

    public void removeModule(Module module);

    public List getSecurityRoleList();

    public void setSecurityRoleList(List securityRoleList);

    public void addSecurityRole(SecurityRole securityRole);

    public void removeSecurityRole(SecurityRole securityRole);

    public String getId();

    public void setId(String id);

    public void marshal(File file) throws IOException;

    public void marshal(OutputStream outputStream) throws IOException;

    public void marshal(Writer writer) throws IOException;

}
