/**
 * This class was generated from a set of XML constraints
 *   by the Enhydra Zeus XML Data Binding Framework. All
 *   source code in this file is constructed specifically
 *   to work with other Zeus-generated classes. If you
 *   modify this file by hand, you run the risk of breaking
 *   this interoperation, as well as introducing errors in
 *   source code compilation.
 *
 * * * * * MODIFY THIS FILE AT YOUR OWN RISK * * * * *
 *
 * To find out more about the Enhydra Zeus framework, you
 *   can point your browser at <http://zeus.enhydra.org>
 *   where you can download releases, join and discuss Zeus
 *   on user and developer mailing lists, and access source
 *   code. Please report any bugs through that website.
 */
package org.objectweb.jonas_web.deployment.xml;

// Global Implementation Import Statements
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Reader;
import java.io.Writer;
import org.xml.sax.Attributes;
import org.xml.sax.EntityResolver;
import org.xml.sax.ErrorHandler;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.XMLReaderFactory;

// Local Implementation Import Statements
import java.util.Iterator;
import java.util.List;
import java.util.LinkedList;

public class JonasWebAppImpl extends DefaultHandler implements Unmarshallable, JonasWebApp {

    private List jonasResourceEnvList;
    private List jonasResourceList;
    private List jonasEjbRefList;
    private Host host;
    private ContextRoot contextRoot;

    /** The current node in unmarshalling */
    private Unmarshallable zeus_currentUNode;

    /** The parent node in unmarshalling */
    private Unmarshallable zeus_parentUNode;

    /** Whether this node has been handled */
    private boolean zeus_thisNodeHandled = false;

    /** The EntityResolver for SAX parsing to use */
    private static EntityResolver entityResolver;

    /** The ErrorHandler for SAX parsing to use */
    private static ErrorHandler errorHandler;

    public JonasWebAppImpl() {
        jonasResourceEnvList = new LinkedList();
        jonasResourceList = new LinkedList();
        jonasEjbRefList = new LinkedList();
    }

    public List getJonasResourceEnvList() {
        return jonasResourceEnvList;
    }

    public void setJonasResourceEnvList(List jonasResourceEnvList) {
        this.jonasResourceEnvList = jonasResourceEnvList;
    }

    public void addJonasResourceEnv(JonasResourceEnv jonasResourceEnv) {
        jonasResourceEnvList.add(jonasResourceEnv);
    }

    public void removeJonasResourceEnv(JonasResourceEnv jonasResourceEnv) {
        jonasResourceEnvList.remove(jonasResourceEnv);
    }

    public List getJonasResourceList() {
        return jonasResourceList;
    }

    public void setJonasResourceList(List jonasResourceList) {
        this.jonasResourceList = jonasResourceList;
    }

    public void addJonasResource(JonasResource jonasResource) {
        jonasResourceList.add(jonasResource);
    }

    public void removeJonasResource(JonasResource jonasResource) {
        jonasResourceList.remove(jonasResource);
    }

    public List getJonasEjbRefList() {
        return jonasEjbRefList;
    }

    public void setJonasEjbRefList(List jonasEjbRefList) {
        this.jonasEjbRefList = jonasEjbRefList;
    }

    public void addJonasEjbRef(JonasEjbRef jonasEjbRef) {
        jonasEjbRefList.add(jonasEjbRef);
    }

    public void removeJonasEjbRef(JonasEjbRef jonasEjbRef) {
        jonasEjbRefList.remove(jonasEjbRef);
    }

    public Host getHost() {
        return host;
    }

    public void setHost(Host host) {
        this.host = host;
    }

    public ContextRoot getContextRoot() {
        return contextRoot;
    }

    public void setContextRoot(ContextRoot contextRoot) {
        this.contextRoot = contextRoot;
    }

    public void marshal(File file) throws IOException {
        // Delegate to the marshal(Writer) method
        marshal(new FileWriter(file));
    }

    public void marshal(OutputStream outputStream) throws IOException {
        // Delegate to the marshal(Writer) method
        marshal(new OutputStreamWriter(outputStream));
    }

    public void marshal(Writer writer) throws IOException {
        // Write out the XML declaration
        writer.write("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n\n");

        // Now start the recursive writing
        writeXMLRepresentation(writer, "");

        // Close up
        writer.flush();
        writer.close();
    }

    protected void writeXMLRepresentation(Writer writer,
                                          String indent)
        throws IOException {

        writer.write(indent);
        writer.write("<jonas-web-app");

        // Handle attributes (if needed)
        writer.write(">");
        writer.write("\n");

        // Handle child elements
        for (Iterator i=jonasResourceEnvList.iterator(); i.hasNext(); ) {
            JonasResourceEnvImpl jonasResourceEnv = (JonasResourceEnvImpl)i.next();
            jonasResourceEnv.writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }
        for (Iterator i=jonasResourceList.iterator(); i.hasNext(); ) {
            JonasResourceImpl jonasResource = (JonasResourceImpl)i.next();
            jonasResource.writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }
        for (Iterator i=jonasEjbRefList.iterator(); i.hasNext(); ) {
            JonasEjbRefImpl jonasEjbRef = (JonasEjbRefImpl)i.next();
            jonasEjbRef.writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }
        if (host != null) {
            ((HostImpl)host).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (contextRoot != null) {
            ((ContextRootImpl)contextRoot).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        writer.write(indent);
        writer.write("</jonas-web-app>\n");
    }

    private String escapeAttributeValue(String attributeValue) {
        String returnValue = attributeValue;
        for (int i = 0; i < returnValue.length(); i++) {
            char ch = returnValue.charAt(i);
            if (ch == '"') {
                returnValue = new StringBuffer()
                    .append(returnValue.substring(0, i))
                    .append("&quot;")
                    .append(returnValue.substring(i+1))
                    .toString();
            }
        }
        return returnValue;
    }

    /**
     * <p>
     *  This sets a SAX <code>EntityResolver</code> for this unmarshalling process.
     * </p>
     *
     * @param resolver the entity resolver to use.
     */
    public static void setEntityResolver(EntityResolver resolver) {
        entityResolver = resolver;
    }

    /**
     * <p>
     *  This sets a SAX <code>ErrorHandler</code> for this unmarshalling process.
     * </p>
     *
     * @param handler the entity resolver to use.
     */
    public static void setErrorHandler(ErrorHandler handler) {
        errorHandler = handler;
    }

    public static JonasWebApp unmarshal(File file) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new FileReader(file));
    }

    public static JonasWebApp unmarshal(File file, boolean validate) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new FileReader(file), validate);
    }

    public static JonasWebApp unmarshal(InputStream inputStream) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new InputStreamReader(inputStream));
    }

    public static JonasWebApp unmarshal(InputStream inputStream, boolean validate) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new InputStreamReader(inputStream), validate);
    }

    public static JonasWebApp unmarshal(Reader reader) throws IOException {
        // Delegate with default validation value
        return unmarshal(reader, false);
    }

    public static JonasWebApp unmarshal(Reader reader, boolean validate) throws IOException {
        JonasWebAppImpl jonasWebApp = new JonasWebAppImpl();
        jonasWebApp.setCurrentUNode(jonasWebApp);
        jonasWebApp.setParentUNode(null);
        // Load the XML parser
        XMLReader parser = null;
        String parserClass = System.getProperty("org.xml.sax.driver",
            "org.apache.xerces.parsers.SAXParser");
        try {
            parser = XMLReaderFactory.createXMLReader(parserClass);

            // Set entity resolver, if needed
            if (entityResolver != null) {
                parser.setEntityResolver(entityResolver);
            }

            // Set error handler, if needed
            if (errorHandler != null) {
                parser.setErrorHandler(errorHandler);
            }

            // Register content handler
            parser.setContentHandler(jonasWebApp);
        } catch (SAXException e) {
            throw new IOException("Could not load XML parser: " + 
                e.getMessage());
        }

        InputSource inputSource = new InputSource(reader);
        try {
            parser.setFeature("http://xml.org/sax/features/validation", new Boolean(validate).booleanValue());
            parser.parse(inputSource);
        } catch (SAXException e) {
            throw new IOException("Error parsing XML document: " + 
                e.getMessage());
        }

        // Return the resultant object
        return jonasWebApp;
    }

    public Unmarshallable getParentUNode() {
        return zeus_parentUNode;
    }

    public void setParentUNode(Unmarshallable parentUNode) {
        this.zeus_parentUNode = parentUNode;
    }

    public Unmarshallable getCurrentUNode() {
        return zeus_currentUNode;
    }

    public void setCurrentUNode(Unmarshallable currentUNode) {
        this.zeus_currentUNode = currentUNode;
    }

    public void startElement(String namespaceURI, String localName,
                             String qName, Attributes atts)
        throws SAXException {

        // Feed this to the correct ContentHandler
        Unmarshallable current = getCurrentUNode();
        if (current != this) {
            current.startElement(namespaceURI, localName, qName, atts);
            return;
        }

        // See if we handle, or we delegate
        if ((localName.equals("jonas-web-app")) && (!zeus_thisNodeHandled)) {
            // Handle ourselves
            for (int i=0, len=atts.getLength(); i<len; i++) {
                String attName= atts.getLocalName(i);
                String attValue = atts.getValue(i);
            }
            zeus_thisNodeHandled = true;
            return;
        } else {
            // Delegate handling
            if (localName.equals("jonas-resource-env")) {
                JonasResourceEnvImpl jonasResourceEnv = new JonasResourceEnvImpl();
                current = getCurrentUNode();
                jonasResourceEnv.setParentUNode(current);
                jonasResourceEnv.setCurrentUNode(jonasResourceEnv);
                this.setCurrentUNode(jonasResourceEnv);
                jonasResourceEnv.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                jonasResourceEnvList.add(jonasResourceEnv);
                return;
            }
            if (localName.equals("jonas-resource")) {
                JonasResourceImpl jonasResource = new JonasResourceImpl();
                current = getCurrentUNode();
                jonasResource.setParentUNode(current);
                jonasResource.setCurrentUNode(jonasResource);
                this.setCurrentUNode(jonasResource);
                jonasResource.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                jonasResourceList.add(jonasResource);
                return;
            }
            if (localName.equals("jonas-ejb-ref")) {
                JonasEjbRefImpl jonasEjbRef = new JonasEjbRefImpl();
                current = getCurrentUNode();
                jonasEjbRef.setParentUNode(current);
                jonasEjbRef.setCurrentUNode(jonasEjbRef);
                this.setCurrentUNode(jonasEjbRef);
                jonasEjbRef.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                jonasEjbRefList.add(jonasEjbRef);
                return;
            }
            if (localName.equals("host")) {
                HostImpl host = new HostImpl();
                current = getCurrentUNode();
                host.setParentUNode(current);
                host.setCurrentUNode(host);
                this.setCurrentUNode(host);
                host.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.host = host;
                return;
            }
            if (localName.equals("context-root")) {
                ContextRootImpl contextRoot = new ContextRootImpl();
                current = getCurrentUNode();
                contextRoot.setParentUNode(current);
                contextRoot.setCurrentUNode(contextRoot);
                this.setCurrentUNode(contextRoot);
                contextRoot.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.contextRoot = contextRoot;
                return;
            }
        }
    }

    public void endElement(String namespaceURI, String localName,
                           String qName)
        throws SAXException {

        Unmarshallable current = getCurrentUNode();
        if (current != this) {
            current.endElement(namespaceURI, localName, qName);
            return;
        }

        Unmarshallable parent = getCurrentUNode().getParentUNode();
        if (parent != null) {
            parent.setCurrentUNode(parent);
        }
    }

    public void characters(char[] ch, int start, int len)
        throws SAXException {

        // Feed this to the correct ContentHandler
        Unmarshallable current = getCurrentUNode();
        if (current != this) {
            current.characters(ch, start, len);
            return;
        }

        String text = new String(ch, start, len);
        text = text.trim();
    }

}
